# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import logging
# import time
# from imaplib import IMAP4
# from imaplib import IMAP4_SSL
# from poplib import POP3
# from poplib import POP3_SSL
# try:
#     import cStringIO as StringIO
# except ImportError:
#     import StringIO

# import zipfile
# import base64
import os
from openerp import addons

from openerp.osv import fields, osv
from openerp import tools
from openerp.tools.translate import _

_logger = logging.getLogger(__name__)

class fetchmail_adhoc(osv.osv):
    """??????"""
    _name = 'fetchmail.adhoc.config'
    _description = "Fetchmail Adhoc Config"

    _columns = {
        'name':fields.char('Name', required=True,),
        'openerp_mailgate_path':fields.char('OpenERP Mailgate Path', required=True,),
        'virtual_aliases':fields.char('Virtual Aliases', required=True,),
        'aliases':fields.char('Aliases', required=True,),
        'database':fields.char('Database', required=True,),
        'host':fields.char('Host', required=True,),
        'port':fields.char('Port', required=True,),
    }

    _defaults = {
        'virtual_aliases': '/etc/postfix/virtual_aliases',
        'aliases': '/etc/aliases',
        }

    def submit_config(self, cr, uid, ids, context=None):
        for record in self.browse(cr, uid, ids, context=context):
            # We add the virtual aliases line
            virtual_aliases_path = record.virtual_aliases
            virtual_aliases = 'aaaaaaaaaaaaaaaaaaaaaa'
            self.add_line(cr, uid, virtual_aliases_path, virtual_aliases, context=context)
            
            # We add the virtual aliases
            aliases_path = record.aliases
            aliases = 'aaaaaaaaaaaaaaaaaaaaaa'            
            self.add_line(cr, uid, aliases_path, aliases, context=context)

            # we run the post config commands
            self.execute_files

    def execute_files(self, cr, uid, context=None):
        try:
            os.system('postmap /etc/postfix/virtual_aliases')
            os.system('newaliases')
            os.system('service postfix restart')
        except IOError:
            pass            

    def add_line(self, cr, uid, file_path, text, context=None):
        if not self.look_for_line(cr, uid, file_path, text, context=context):
            self.write_new_line(cr, uid, file_path, text, context=context)        

    def write_new_line(self, cr, uid, file_path, text, context=None):
        try:
            temp_file = open(file_path, 'a')
            try:
                temp_file.write(text + '\n')
            finally:
                temp_file.close()
        except IOError:
            pass                

    def look_for_line(self, cr, uid, file_path, text, context=None):
        try:
            temp_file = open(file_path, 'r')
            for line in temp_file.readlines():
                if text in line:
                    temp_file.close()
                    return True
            temp_file.close()
        except IOError:
            pass            
        return False

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
